<template>
    <div class="container mt-5">
        <div class="row">
            <div class="col-md-12">
                <div class="card border-0 rounded shadow">
                    <div class="card-body">
                        <h4>Edit BUKU</h4>
                        <hr>
                        <form @submit.prevent="update">
                            <div class="form-group">
                                <label for="title" class="font-weight-bold">TITLE</label>
                                <input type="text" class="form-control" v-model="buku.judul"
                                    placeholder="Masukkan Judul Buku">
                                <!-- validation -->
                                <div v-if="validation.judul" class="mt-2 alert alert-danger">
                                    {{ validation.judul[0] }}
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="content" class="font-weight-bold">CONTENT</label>
                                <input type="text" class="form-control" v-model="buku.sampul"
                                    placeholder="Masukkan Sampul File">
                                <!-- validation -->
                                <div v-if="validation.sampul" class="mt-2 alert alert-danger">
                                    {{ validation.sampul[0] }}
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="content" class="font-weight-bold">Penerbit</label>
                                <select class="form-control" v-model="buku.penerbit_id">
                                    <option value=1>Erlangga</option>
                                    <option value=2>Gramedia</option>
                                </select>
                                <div v-if="validation.sampul" class="mt-2 alert alert-danger">
                                    {{ validation.sampul[0] }}
                                </div>
                            </div>

                            <hr>
                            <div class="form-group">
                                <button type="submit" class="btn btn-primary">SIMPAN</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { reactive, ref, onMounted } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import axios from 'axios'
export default {
    setup() {

        //state posts
        const buku = reactive({
            judul: '',
            sampul: '',
            penerbit_id: 1
        })

        //state validation
        const validation = ref([])

        //vue router
        const router = useRouter()
        //vue router
        const route = useRoute()
        //mounted
        onMounted(() => {

            //get API from Laravel Backend
            axios.get(`http://localhost:8000/api/buku/${route.params.id}`)
                .then(response => {

                    //assign state posts with response data
                    buku.judul = response.data.judul
                    buku.sampul = response.data.sampul
                    buku.penerbit_id = response.data.penerbit_id 

                }).catch(error => {
                    console.log(error.response.data)
                })
        })
        //method update
        function update() {
            let judul = buku.judul
            let sampul = buku.sampul
            let penerbit_id = buku.penerbit_id
            axios.put(`http://localhost:8000/api/buku/${route.params.id}`, {
                judul: judul,
                sampul: sampul,
                penerbit_id: penerbit_id
            }).then(() => {
                //redirect ke post index
                router.push({
                    name: 'buku.index'
                })
            }).catch(error => {
                //assign state validation with error 
                validation.value = error.response.data
            })
        }

        //return
        return {
            buku,
            validation,
            router,
            update
        }
    }
}
</script>
<style>
body {
    background: lightgray;
}
</style>